var selectedFiles = [];

function handleFileSelect(event) {
    var files = event.target.files;
    var fileCount = files.length;

    if (fileCount > 0) {
        for (var i = 0; i < fileCount; i++) {
            selectedFiles.push(files[i]);
        }

        updateSelectedFilesDisplay();
        document.getElementById("submitBtn").disabled = false;
    }
}

function updateSelectedFilesDisplay() {
    var selectedFilesContainer = document.getElementById("selectedFilesContainer");
    selectedFilesContainer.innerHTML = "";

    for (var i = 0; i < selectedFiles.length; i++) {
        var file = selectedFiles[i];

        var fileItem = document.createElement("div");
        fileItem.classList.add("file-item");

        var fileIcon = document.createElement("span");
        fileIcon.classList.add("file-icon");
        fileIcon.textContent = "📄";

        var fileName = document.createElement("span");
        fileName.classList.add("file-name");
        fileName.textContent = file.name;

        var removeButton = document.createElement("span");
        removeButton.classList.add("remove-button");
        removeButton.textContent = "X";
        removeButton.dataset.index = i;
        removeButton.addEventListener("click", handleRemoveFile);

        fileItem.appendChild(fileIcon);
        fileItem.appendChild(fileName);
        fileItem.appendChild(removeButton);
        selectedFilesContainer.appendChild(fileItem);
    }
}

function handleRemoveFile(event) {
    var index = event.target.dataset.index;
    selectedFiles.splice(index, 1);
    updateSelectedFilesDisplay();
}

function handleUpload() {
    var fileCount = selectedFiles.length;

    if (fileCount > 0) {
        // Hide delete buttons
        var deleteButtons = document.querySelectorAll(".remove-button");
        deleteButtons.forEach(function (btn) {
            btn.classList.add("hidden");
        });

        document.getElementById("dropArea").classList.add("uploading");
        document.getElementById("statusText").textContent = "Uploading...";
        document.getElementById("progressContainer").style.display = "block";
        document.getElementById("progressBar").style.width = "0%";
        document.getElementById("submitBtn").disabled = true;
        document.getElementById("fileInput").disabled = true;
        document.getElementById("dropArea").classList.add("disabled"); // Add disabled class to the drop area
        document.getElementById("fileInput").classList.add("disabled"); // Add disabled class to the file input

        var uploadedCount = 0;

        function handleUploadSuccess() {
            uploadedCount++;

            if (uploadedCount === fileCount) {
                console.log("All files sent to Switch successfully.");

                document.getElementById("dropArea").classList.remove("uploading");
                document.getElementById("statusText").textContent = "Finished!";
                document.getElementById("submitBtn").disabled = false;
                document.getElementById("fileInput").disabled = false;
                document.getElementById("dropArea").classList.remove("disabled"); // Remove disabled class from the drop area
                document.getElementById("fileInput").classList.remove("disabled"); // Remove disabled class from the file input

            }
        }
        // get server, username, password, submit point name, and submit file
        server = "127.0.0.1:51088"		// for testing on local PC use:  10.103.89.15:51088
        username = "dgordeyev"
        password = "testing123"
        submit_point_name = "Word2PDF_POC"

        function sendFileToSwitch(server, username, password, submit_point_name, submit_file) {
            const publicKey = `
            -----BEGIN PUBLIC KEY-----
MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQC/ZW93qx1U6iGDwFWjYRpgS6/l
vFV/VGEM7wV14Gr4ZZxpZto3rpot3As4Cn0a++LwVh1oSidmiRWnHcKBDCmov8IL
fJ6SckFV41WZWibx8eSTCfn6zlrQ6QgJC2jdpLbWewxhox58zVXk5iK67GOKqbE/
HzSFJVdqIyjNX0/IpQIDAQAB
-----END PUBLIC KEY-----
`;

            // RSA encrypt password using jsrsasign library
            function encryptWithRSAPublicKey(publicKey, plaintext) {
                const rsaPublicKey = KEYUTIL.getKey(publicKey);
                const encrypted = rsaPublicKey.encrypt(plaintext);
                return hextob64(encrypted);
            }

            const encryptedPassword = encryptWithRSAPublicKey(publicKey, password); //"JsRXFAHQ1pfOgXc+IO7PqEW17+RskBLWgvUx0EkVIUaU6w26qkVlEG/UgmJfsNAeCiWISSBo0Kns6RXIN6w2OetDqg+ZfkLQi+DpDgmSPVXxHGTJrIAG5KWNjIKTKfm6LB68RJhkLY9J8x424GgspGLgBwZcmAaN1vpwqER4u0M="

            const loginUrl = `http://${server}/login`;
            const loginHeaders = { 'Content-Type': 'application/json' };
            const loginData = JSON.stringify({ 'username': username, 'password': '!@$' + encryptedPassword });

            return fetch(loginUrl, {
                method: 'POST',
                headers: loginHeaders,
                body: loginData
            })
                .then(response => response.json())
                .then(result => {
                    if (!result.success) {
                        throw new Error("Error message after login: " + result.message);
                    }

                    const token = result.token;

                    const submitPointsUrl = `http://${server}/api/v1/submitpoints`;
                    const submitPointsHeaders = { 'Authorization': 'Bearer ' + token };

                    return fetch(submitPointsUrl, { headers: submitPointsHeaders })
                        .then(response => response.json())
                        .then(result => {
                            let flowId = "";//'141'
                            let submitPointId = "";//'12'

                            result.forEach(submitPoint => {
                                if (submitPoint.name === submit_point_name) {
                                    submitPointId = submitPoint.objectId;
                                    flowId = submitPoint.flowId;
                                }
                            });

                            if (submitPointId === "") {
                                throw new Error("Error message: submit point with name " + submit_point_name + " not found");
                            }
                            const test = "HelloDima";

                            const form = new FormData();
                            form.append('file', submit_file, { filename: submit_file.name, contentType: 'text/plain' });
                            form.append('flowId', flowId);
                            form.append('modified', '2017-09-30T08:18:50.000Z');
                            form.append('objectId', submitPointId);
                            form.append('filePath', submit_file.name);
                            form.append('jobName', submit_file.name);

                            console.log('FormData:', form);
                            for (var pair of form.entries()) {
                                console.log(pair[0] + ', ' + pair[1]);
                            }


                            const jobUrl = `http://${server}/api/v1/job`;
                            const jobHeaders = {
                                'Authorization': 'Bearer ' + token,
                                'Content-Length': , //populate with the number that the Documentation auto generates when uploading a sample file
                                'Content-Type': 'multipart/form-data; boundary=----WebKitFormBoundaryPEVBKFgKPxbsxTfP'
                            };

                            return fetch(jobUrl, {
                                method: 'POST',
                                headers: jobHeaders,
                                body: form
                            })

                                .then(response =>  response.json())
                                .catch(error => {
                                    console.error('Job submission error:', error);
                                });
                        })
                        .catch(error => {
                            console.error('Submit points retrieval error:', error);
                        });
                })
                .catch(error => {
                    console.error('Login error:', error);
                });
        }

        for (var i = 0; i < fileCount; i++) {
            var file = selectedFiles[i];
            var reader = new FileReader();

            reader.onload = function (event) {
                var fileData = event.target.result;

                sendFileToSwitch(server, username, password, submit_point_name, file)
                    .then(handleUploadSuccess)
                    .catch(function (error) {
                        console.error('File upload error:', error);
                    });
            };

            reader.readAsText(file);
        }
    }
}

document.getElementById("fileInput").addEventListener("change", handleFileSelect);
document.getElementById("submitBtn").addEventListener("click", handleUpload);
